// Generated by CoffeeScript 1.9.1
(function() {
  var async, pengines, prologdb, qs, simpleAuth;

  qs = require('qs');

  pengines = require('pengines');

  simpleAuth = require('./simpleAuth');

  async = require('async');


  /* Begin non-static version
  class PrologDb
      
      #Map between the ids of the pengines and the pangines themselves. Needs to be kept track of because there needs to be a cleanup to destroy all the slaves
      openQueries = {}
      
      
      constructor : (options) ->
          {@authOptions, @applicationName, @serverUrl, @maxQueryLength, @sourceText} = options
          @maxQueryLength ?= 1000
          @applicationName ?= "swish"
          @sourceText ?= ""
          
          
      authenticate : (callback) =>
          
          if @authOptions?
              simpleAuth @authOptions, (error,...,cookieJar) =>
                  @cookieJar = cookieJar
                  callback(error,@)
          else
              @cookieJar = request.jar()
              callback(null,@)
      
      
      addPresetSourceText : (sourceText,callback) ->
          @sourceText = if @sourceText? then "#{@sourceText}\n#{fileContent}" else sourceText
  
      #Perform a connection straight away without going through constructor (convenience method inspired by mongoDB npm module)
      @connect : (options,callback) ->
          #newPrologDb =
          
          new PrologDb(options).open( (error,newPrologDb) =>
              callback(error,newPrologDb)
          )
          
      query : (queryString,callback) =>
          queryN(queryString,@maxQueryLength,callback)
      
      queryN : (queryString,chunk,callback) =>
          
  
          
          pengineOptions =
              server: @serverUrl,
              #Not sure if it is ideal to have "swish" here, dunno what it really affects
              application: @applicationName,
              #The json-s is necessary to avoid internal server error when retreiving different types, like literal(...)
              format: "json",
              destroy: true,
              sourceText: @sourceText,
              ask: queryString,
              chunk: chunk,
              cookieJar: @cookieJar
          
          
          queryResult = null
          
          peng = pengines(pengineOptions)
              .on('error',(obj) -> callback(new Error("Error in operation: #{obj.data}")))
              .on('failure',(error) -> callback(new Error("Pengine object failed: #{obj.data}")))
              .on('destroy', ->
                      callback null,queryResult
                  )
              .on('success', (result) ->
                  queryResult = result
                  peng.destroy()
              )
              
      
      queryMore : (queryId,callback) ->
          openQuery = openQueries[queryId]
          callback ?= openQuery.initialCallback
          
          openQuery.once('success',(result) ->
              callback(null,result,queryId)
          )
          
          openQuery.next()
              
          
      closeQuery : (queryId,callback) ->
          openQueries[queryId].destroy().on('destroy',callback)
      
      #Asks for a number of entries and allow for asking for more entries
      openQuery : (queryString,nEntries,callback) =>
          
          
          peng = pengines(
                  server: @serverUrl
                  application: @applicationName,
                  #The json-s is necessary to avoid internal server error when retreiving different types, like literal(...)
                  format: "json",
                  destroy: false,
                  sourceText: @sourceText,
                  ask: queryString,
                  chunk: nEntries,
                  cookieJar: @cookieJar
              )
              .on('error',(obj) -> callback(new Error("Error in operation: #{obj.data}")))
              .on('failure',(obj) ->
                  callback(new Error("Pengine object failed: #{JSON.stringify(obj)}")))
              .on('create', (result) ->
                  openQueries[peng.id] = peng
                  openQueries[peng.id].initialCallback = callback
              )
              .once('success', (result) ->
                  #If there are more results to obtain, attach a callback to get more data
                  callback(null,result,peng.id)
              )
          
      @cleanUp : ->
          for id, peng of openQueries
              if peng.died
                  #Todo: investigate if there is a risk for concurrent modification
                  delete openQueries[id]
              else
                  #TODO: Currently, we don't wait for callback here. Reconsider a synchronous solution?
                  peng.destroy()
   */

  prologdb = function(options) {
    var applicationName, authOptions, cleanUp, cookieJar, maxQueryLength, openQueries, serverUrl, sourceText;
    openQueries = {};
    authOptions = options.authOptions, applicationName = options.applicationName, serverUrl = options.serverUrl, maxQueryLength = options.maxQueryLength, sourceText = options.sourceText;
    if (maxQueryLength == null) {
      maxQueryLength = 1000;
    }
    if (applicationName == null) {
      applicationName = "swish";
    }
    if (sourceText == null) {
      sourceText = "";
    }
    cookieJar = null;
    prologdb.setMaxQueryLength = function(newLength) {
      return maxQueryLength = newLength;
    };
    prologdb.authenticate = function(callback) {
      if (authOptions != null) {
        return simpleAuth(authOptions, (function(_this) {
          return function() {
            var error, newCookieJar;
            error = arguments[0], newCookieJar = arguments[arguments.length - 1];
            cookieJar = newCookieJar;
            return callback(error);
          };
        })(this));
      } else {
        cookieJar = request.jar();
        return callback(null);
      }
    };
    prologdb.addPresetSourceText = function(sourceTextNew, callback) {
      return sourceText = sourceText != null ? sourceText + "\n" + sourceTextNew : sourceTextNew;
    };
    prologdb.query = (function(_this) {
      return function(queryString, callback) {
        return prologdb.queryN(queryString, maxQueryLength, callback);
      };
    })(this);
    prologdb.queryN = (function(_this) {
      return function(queryString, chunk, callback) {
        var peng, pengineOptions, queryResult;
        pengineOptions = {
          server: serverUrl,
          application: applicationName,
          format: "json",
          destroy: true,
          sourceText: sourceText,
          ask: queryString,
          chunk: maxQueryLength,
          cookieJar: cookieJar
        };
        queryResult = null;
        return peng = pengines(pengineOptions).on('error', function(obj) {
          return callback(new Error("Error in operation: " + obj.data));
        }).on('failure', function(obj) {
          obj.data = [];
          return callback(null, obj);
        }).on('destroy', function() {
          console.log("Destroying");
          if (queryResult) {
            return callback(null, queryResult);
          }
        }).on('success', function(result) {
          queryResult = result;
          return peng.destroy();
        });
      };
    })(this);
    prologdb.queryMore = function(queryId, callback) {
      var openQuery;
      openQuery = openQueries[queryId];
      if (callback == null) {
        callback = openQuery.initialCallback;
      }
      openQuery.once('success', function(result) {
        return callback(null, result, queryId);
      });
      return openQuery.next();
    };
    prologdb.closeQuery = function(queryId, callback) {
      return openQueries[queryId].destroy().on('destroy', callback);
    };
    prologdb.openQuery = (function(_this) {
      return function(queryString, nEntries, callback) {
        var peng;
        return peng = pengines({
          server: serverUrl,
          application: applicationName,
          format: "json",
          destroy: false,
          sourceText: sourceText,
          ask: queryString,
          chunk: nEntries,
          cookieJar: cookieJar
        }).on('error', function(obj) {
          return callback(new Error("Error in operation: " + obj.data));
        }).on('failure', function(obj) {
          obj.data = [];
          return callback(null, obj, peng.id);
        }).on('create', function(result) {
          openQueries[peng.id] = peng;
          return openQueries[peng.id].initialCallback = callback;
        }).once('success', function(result) {
          return callback(null, result, peng.id);
        });
      };
    })(this);
    cleanUp = function() {
      var id, peng, results;
      results = [];
      for (id in openQueries) {
        peng = openQueries[id];
        if (peng.died) {
          results.push(delete openQueries[id]);
        } else {
          results.push(peng.destroy());
        }
      }
      return results;
    };
    return prologdb;
  };


  /*
  staticDb = null
  
  
  
  staticExport = (opts) ->
      staticDb = new PrologDb(opts)
   */


  /*
  for funcName,func of PrologDb.prototype
      
      eachFunc = (fName) -> (
          staticExport[fName] =  ((args...) ->
              staticDb[fName](args...)))
      
      eachFunc(funcName)
   */

  module.exports = prologdb;

}).call(this);
